## percona-server-mongodb 4.2.17

=== debian/changelog ===
percona-server-mongodb (4.2.17-17) unstable; urgency=medium

  * Update to new Percona Server for MongoDB version 4.2.17

 -- root <root@630a4c905dbf>  Mon, 27 Sep 2021 14:08:51 +0000
